{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
unit Dif;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OGLView,
  OpenGl, OGLClass, OGLCam, OGLLight, OGLCntrl, ExtCtrls;

type
  TForm1 = class(TForm)
    GL1: TOGLView;
    Camera1: TOGLCamera;
    Timer1: TTimer;
    procedure GL1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Angulo:integer;

implementation

{$R *.DFM}

procedure DesenhaCubo;
begin

  glColor3f(0.9,0.6,0);
  glBegin(GL_POLYGON); // face posterior
    glNormal3f(0,0,1);
    glVertex3f(10.0, 10.0, 10.0);
    glVertex3f(-10.0, 10.0, 10.0);
    glVertex3f(-10.0, -10.0, 10.0);
    glVertex3f(10.0, -10.0, 10.0);
  glEnd;


  glBegin(GL_POLYGON);  // face frontal
    glNormal3f(0,0,-1);
    glVertex3f(10.0, 10.0, -10.0);
    glVertex3f(10.0, -10.0, -10.0);
    glVertex3f(-10.0, -10.0, -10.0);
    glVertex3f(-10.0, 10.0, -10.0);
  glEnd;

  glBegin(GL_POLYGON);  //  face lateral esquerda
    glNormal3f(-1,0,0);
    glVertex3f(-10.0, 10.0, 10.0);
    glVertex3f(-10.0, 10.0, -10.0);
    glVertex3f(-10.0, -10.0, -10.0);
    glVertex3f(-10.0, -10.0, 10.0);
  glEnd;

  glBegin(GL_POLYGON);   //  face lateral direita
    glNormal3f(1,0,0);
    glVertex3f(10.0, 10.0, 10.0);
    glVertex3f(10.0, -10.0, 10.0);
    glVertex3f(10.0, -10.0, -10.0);
    glVertex3f(10.0, 10.0, -10.0);
  glEnd;

  glBegin(GL_POLYGON);  //  face superior
    glNormal3f(0,1,0);
    glVertex3f(-10.0, 10.0, -10.0);
    glVertex3f(-10.0, 10.0, 10.0);
    glVertex3f(10.0, 10.0, 10.0);
    glVertex3f(10.0, 10.0, -10.0);
  glEnd;

  glBegin(GL_POLYGON);   //  face inferior
    glNormal3f(0,-1,0);
    glVertex3f(-10.0, -10.0, -10.0);
    glVertex3f(10.0, -10.0, -10.0);
    glVertex3f(10.0, -10.0, 10.0);
    glVertex3f(-10.0, -10.0, 10.0);
  glEnd;
end;

procedure DefineLuz;
const
  LuzAmbiente : Array[0..3] of GLfloat = (0.5, 0.5, 0.5, 1.0);
  LuzDifusa   : Array[0..3] of GLfloat = (0.8, 0.8, 0.8, 1.0);
  PosicaoLuz  : Array[0..3] of GLfloat = (30.0, 30.0, 0.0, 1.0);

begin

   // Habilita o uso de iluminao
  glEnable(GL_LIGHTING);

  // Ativa o uso da luz ambiente
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @LuzAmbiente);

  // Define os parametros da Luz nmero Zero
  glLightfv(GL_LIGHT0, GL_AMBIENT, @LuzAmbiente);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, @LuzDifusa  );
  glLightfv(GL_LIGHT0, GL_POSITION,@PosicaoLuz );
  glEnable(GL_LIGHT0);

  // Ativa o "Color Tracking"
  glEnable(GL_COLOR_MATERIAL);

  // Exibe uma linha da luz at (0,0,0)
  glBegin(GL_LINES);
    glVertex3f(0,0,0);
    glVertex4fv(@PosicaoLuz);
  glEnd;

end;

procedure TForm1.GL1Paint(Sender: TObject);
begin
  DefineLuz;
  glRotatef(Angulo,0,1,0);
  DesenhaCubo;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Angulo:= Angulo + 1;
  if Angulo = 360
  then Angulo := 0;
  GL1.InvalidateGL;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Angulo := 45;
end;

end.


{
LUZ
 const
  glfLightAmbient : Array[0..3] of GLfloat = (0.1, 0.1, 0.1, 1.0);
  glfLightDiffuse : Array[0..3] of GLfloat = (0.7, 0.7, 0.7, 1.0);
  glfLightSpecular: Array[0..3] of GLfloat = (0.0, 0.0, 0.0, 1.0);

begin
  //
  // Enable depth testing and backface culling.
  //
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);

  //
  // Add a light to the scene.
  //
  glLightfv(GL_LIGHT0, GL_AMBIENT, @glfLightAmbient);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, @glfLightDiffuse);
  glLightfv(GL_LIGHT0, GL_SPECULAR,@glfLightSpecular);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
end;

}
